;******************************************************************************
;* TMS320C6x ANSI C Codegen                                      Version 3.01 *
;* Date/Time created: Tue Nov 21 12:52:59 2000                                *
;******************************************************************************

;******************************************************************************
;* GLOBAL FILE PARAMETERS                                                     *
;*                                                                            *
;*   Architecture        : TMS320C6200                                        *
;*   Endian              : Little                                             *
;*   Interrupt Threshold : Disabled                                           *
;*   Memory Model        : Small                                              *
;*   Calls to RTS        : Near                                               *
;*   Pipelining          : Enabled                                            *
;*   Speculative Load    : Threshold = 0                                      *
;*   Epilog Collapsing   : Enabled                                            *
;*   Prolog Collapsing   : Enabled                                            *
;*   Redundant Loops     : Enabled                                            *
;*   Code Size Opt.      : Disabled                                           *
;*   Memory Aliases      : Presume are aliases (pessimistic)                  *
;*   Debug Info          : Debug                                              *
;*                                                                            *
;******************************************************************************

FP	.set	A15
DP	.set	B14
SP	.set	B15
	.global	$bss

;	opt6x -O3 C:\TEMP\tempTI2 C:\TEMP\tempTI7 
	.file	"Dma_ex.c"
	.file	"c:\evm6x\dsp\include\board.h"
	.file	"c:\evm6x\dsp\include\dma.h"
	.file	"Dma_ex.c"

	.sect	".cinit:c"
	.align	8
	.field  	(CIR - $) - 8, 32
	.field  	_pri_ctl+0,32
	.field  	0,32			; _pri_ctl @ 0

	.sect	".text"
_pri_ctl:	.usect	".bss:c",4,4
	.sym	_pri_ctl,_pri_ctl, 14, 3, 32

	.sect	".cinit:c"
	.align	4
	.field  	0,32			; _sec_ctl @ 0

	.sect	".text"
_sec_ctl:	.usect	".bss:c",4,4
	.sym	_sec_ctl,_sec_ctl, 14, 3, 32

	.sect	".cinit:c"
	.align	4
	.field  	0,32			; _src_addr @ 0

	.sect	".text"
_src_addr:	.usect	".bss:c",4,4
	.sym	_src_addr,_src_addr, 14, 3, 32

	.sect	".cinit:c"
	.align	4
	.field  	0,32			; _dst_addr @ 0

	.sect	".text"
_dst_addr:	.usect	".bss:c",4,4
	.sym	_dst_addr,_dst_addr, 14, 3, 32

	.sect	".cinit:c"
	.align	4
	.field  	0,32			; _trans_ctr @ 0

	.sect	".text"
_trans_ctr:	.usect	".bss:c",4,4
	.sym	_trans_ctr,_trans_ctr, 14, 3, 32
	.sect	".text"
	.global	_test_DMA_channel
	.sym	_test_DMA_channel,_test_DMA_channel, 32, 2, 0
	.func	93

;******************************************************************************
;* FUNCTION NAME: _test_DMA_channel                                           *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,B0,B1,B2,B3,B4,B5, *
;*                           B6,B7,B8,B9,B10,SP                               *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,B0,B1,B2,B3,B4,B5, *
;*                           B6,B7,B8,B9,B10,DP,SP                            *
;*   Local Frame Size  : 0 Args + 0 Auto + 12 Save = 12 byte                  *
;******************************************************************************
_test_DMA_channel:
;** --------------------------------------------------------------------------*
	.sym	_src,4, 16, 17, 32
	.sym	_cpuFreqInMhz,4, 4, 4, 32
	.sym	_src,20, 16, 4, 32
           STW     .D2T2   B10,*SP--(16)     ; |93| 
           STW     .D2T1   A10,*+SP(8)       ; |93| 
           STW     .D2T2   B3,*+SP(12)       ; |93| 
	.line	1
           MV      .L2X    A4,B4             ; |93| 
	.line	8
           STW     .D2T2   B4,*+DP(_src_addr) ; |100| 
	.line	9
           LDW     .D2T2   *+DP(_pri_ctl),B4 ; |101| 
           NOP             4
           CLR     .S2     B4,5,5,B4         ; |101| 
           SET     .S2     B4,4,4,B4         ; |101| 
           STW     .D2T2   B4,*+DP(_pri_ctl) ; |101| 
	.line	10
           LDW     .D2T1   *+DP(_pri_ctl),A0 ; |102| 
           NOP             4
           CLR     .S1     A0,28,28,A0       ; |102| 
           SET     .S1     A0,29,29,A0       ; |102| 
           STW     .D2T1   A0,*+DP(_pri_ctl) ; |102| 
	.line	13
           LDW     .D2T2   *+DP(_pri_ctl),B4 ; |105| 
           NOP             4
           CLR     .S2     B4,14,18,B4       ; |105| 
           SET     .S2     B4,15,15,B4       ; |105| 
           STW     .D2T2   B4,*+DP(_pri_ctl) ; |105| 
	.line	14
           B       .S1     _cpu_freq         ; |106| 
           NOP             3
           MVKL    .S2     RL0,B3            ; |106| 
           MVKH    .S2     RL0,B3            ; |106| 
RL0:       ; CALL OCCURS                     ; |106| 
           CMPEQ   .L1     A4,-1,A1          ; 
	.line	16
   [ A1]   MVK     .S1     0x85,A4           ; |108| 
	.line	20
           ZERO    .L1     A0                ; |112| 

           MVK     .S2     704,B4            ; |112| 
||         MVKH    .S1     0x1980000,A0      ; |112| 

           STW     .D1T2   B4,*A0            ; |112| 
           MVK     .S2     11,B5             ; |112| 
           MPYLHU  .M2X    B5,A4,B4          ; |112| 
           MPYU    .M1X    B5,A4,A0          ; |112| 
           SHL     .S2     B4,16,B4          ; |112| 

           ADD     .L1X    A0,B4,A0          ; |112| 
||         MVKL    .S2     0x1980004,B10     ; |112| 

           SHR     .S1     A0,3,A0           ; |112| 
||         MVKH    .S2     0x1980004,B10     ; |112| 

           STW     .D2T1   A0,*B10           ; |112| 
           MVKL    .S1     0x1980008,A10     ; |112| 

           ZERO    .L1     A0                ; |112| 
||         MVKH    .S1     0x1980008,A10     ; |112| 

           STW     .D1T1   A0,*A10           ; |112| 
	.line	21
           LDW     .D2T2   *+SP(12),B3       ; |113| 
           NOP             4

           B       .S2     B3                ; |113| 
||         LDW     .D2T1   *+SP(8),A10       ; |113| 

           LDW     .D2T2   *++SP(16),B10     ; |113| 
           NOP             4
           ; BRANCH OCCURS                   ; |113| 
	.endfunc	113,004080400h,16


	.sect	".text"
	.global	_start_DMA_channel
	.sym	_start_DMA_channel,_start_DMA_channel, 32, 2, 0
	.func	115

;******************************************************************************
;* FUNCTION NAME: _start_DMA_channel                                          *
;*                                                                            *
;*   Regs Modified     : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,B0,B1,B2,  *
;*                           B3,B4,B5,B6,B7,B8,B9,B10,SP                      *
;*   Regs Used         : A0,A1,A2,A3,A4,A5,A6,A7,A8,A9,A10,A11,A12,B0,B1,B2,  *
;*                           B3,B4,B5,B6,B7,B8,B9,B10,DP,SP                   *
;*   Local Frame Size  : 0 Args + 0 Auto + 20 Save = 20 byte                  *
;******************************************************************************
_start_DMA_channel:
;** --------------------------------------------------------------------------*
	.sym	_chan,4, 13, 17, 16
	.sym	C$1,20, 14, 4, 32
	.sym	_chan,11, 13, 4, 16
           STW     .D2T2   B10,*SP--(24)     ; |115| 
           STW     .D2T1   A10,*+SP(8)       ; |115| 
           STW     .D2T1   A11,*+SP(12)      ; |115| 
           STW     .D2T1   A12,*+SP(16)      ; |115| 
           STW     .D2T2   B3,*+SP(20)       ; |115| 
	.line	1
           MV      .L1     A4,A11            ; |115| 
	.line	4
           LDW     .D2T2   *+DP(_src_addr),B6 ; |118| 
           LDW     .D2T1   *+DP(_dst_addr),A8 ; |118| 
           LDW     .D2T2   *+DP(_trans_ctr),B8 ; |118| 

           B       .S1     _dma_init         ; |118| 
||         LDW     .D2T1   *+DP(_sec_ctl),A6 ; |118| 

           LDW     .D2T2   *+DP(_pri_ctl),B4 ; |118| 
           NOP             2
           MVKL    .S2     RL2,B3            ; |118| 
           MVKH    .S2     RL2,B3            ; |118| 
RL2:       ; CALL OCCURS                     ; |118| 
	.line	5
           LDW     .D2T2   *+DP(_src_addr),B10 ; |119| 

           B       .S1     _dma_global_init  ; |119| 
||         LDW     .D2T1   *+DP(_dst_addr),A12 ; |119| 

           LDW     .D2T2   *+DP(_trans_ctr),B4 ; |119| 
           NOP             2

           MVKL    .S2     RL4,B3            ; |119| 
||         ZERO    .L1     A10               ; |119| 

           MVKH    .S2     RL4,B3            ; |119| 
||         ZERO    .L1     A4                ; |119| 
||         ZERO    .L2     B8                ; |119| 
||         ZERO    .S1     A8                ; |119| 
||         ZERO    .D2     B6                ; |119| 
||         ZERO    .D1     A6                ; |119| 

RL4:       ; CALL OCCURS                     ; |119| 
	.line	8
           AND     .L1     1,A11,A0          ; |122| 

           AND     .L1     2,A11,A0          ; |122| 
||         SHL     .S1     A0,6,A3           ; |122| 
||         ZERO    .L2     B4                ; |122| 

           ADDAH   .D1     A3,A0,A0          ; |122| 
||         MVKH    .S2     0x1840000,B4      ; |122| 

           ADD     .L2X    B4,A0,B4          ; |122| 
           LDW     .D2T2   *B4,B5            ; |122| 
           NOP             4
           OR      .L2     3,B5,B5           ; |122| 
           STW     .D2T2   B5,*B4            ; |122| 
	.line	10
           LDW     .D2T2   *+SP(20),B3       ; |124| 
           NOP             2
           LDW     .D2T1   *+SP(16),A12      ; |124| 
           LDW     .D2T1   *+SP(8),A10       ; |124| 

           B       .S2     B3                ; |124| 
||         LDW     .D2T1   *+SP(12),A11      ; |124| 

           LDW     .D2T2   *++SP(24),B10     ; |124| 
           NOP             4
           ; BRANCH OCCURS                   ; |124| 
	.endfunc	124,004081c00h,24


	.sect	".text"
	.global	_program_DMA_channel
	.sym	_program_DMA_channel,_program_DMA_channel, 32, 2, 0
	.func	56

;******************************************************************************
;* FUNCTION NAME: _program_DMA_channel                                        *
;*                                                                            *
;*   Regs Modified     : A0,A1,B4,B5                                          *
;*   Regs Used         : A0,A1,A4,A6,A8,B3,B4,B5,B6,DP                        *
;*   Local Frame Size  : 0 Args + 0 Auto + 0 Save = 0 byte                    *
;******************************************************************************
_program_DMA_channel:
;** --------------------------------------------------------------------------*
	.sym	_dest,4, 16, 17, 32
	.sym	_count,20, 4, 17, 32
	.sym	_nbuf,6, 4, 17, 32
	.sym	_size,22, 14, 17, 32
	.sym	_dmac_en,8, 14, 17, 32
	.sym	_dest,4, 16, 4, 32
	.sym	_count,20, 4, 4, 32
	.sym	_nbuf,6, 4, 4, 32
	.sym	_size,22, 14, 4, 32
	.sym	_dmac_en,8, 14, 4, 32
	.line	2
	.line	7
           LDW     .D2T1   *+DP(_pri_ctl),A0 ; |62| 
           NOP             4
           CLR     .S1     A0,4,5,A0         ; |62| 
           STW     .D2T1   A0,*+DP(_pri_ctl) ; |62| 
	.line	8
           LDW     .D2T2   *+DP(_pri_ctl),B5 ; |63| 
           NOP             4
           CLR     .S2     B5,7,7,B5         ; |63| 
           SET     .S2     B5,6,6,B5         ; |63| 
           STW     .D2T2   B5,*+DP(_pri_ctl) ; |63| 
	.line	9
           LDW     .D2T2   *+DP(_pri_ctl),B5 ; |64| 
           NOP             4
           CLR     .S2     B5,17,18,B5       ; |64| 
           SET     .S2     B5,14,16,B5       ; |64| 
           STW     .D2T2   B5,*+DP(_pri_ctl) ; |64| 
	.line	10
           CMPEQ   .L1     A8,2,A1           ; |65| 
	.line	11
   [ A1]   LDW     .D2T1   *+DP(_pri_ctl),A0 ; |66| 
           NOP             4
   [ A1]   SET     .S1     A0,26,26,A0       ; |66| 
   [ A1]   STW     .D2T1   A0,*+DP(_pri_ctl) ; |66| 
	.line	12
           LDW     .D2T1   *+DP(_pri_ctl),A0 ; |67| 
           NOP             4
           CLR     .S1     A0,19,23,A0       ; |67| 
           STW     .D2T1   A0,*+DP(_pri_ctl) ; |67| 
	.line	13
           LDW     .D2T1   *+DP(_pri_ctl),A0 ; |68| 
           NOP             4
           SET     .S1     A0,25,25,A0       ; |68| 
           STW     .D2T1   A0,*+DP(_pri_ctl) ; |68| 
	.line	14
           LDW     .D2T1   *+DP(_pri_ctl),A0 ; |69| 
           NOP             4

           CLR     .S1     A0,8,9,A0         ; |69| 
||         SHL     .S2     B6,8,B5           ; |69| 

           OR      .L2X    B5,A0,B5          ; |69| 
           STW     .D2T2   B5,*+DP(_pri_ctl) ; |69| 
	.line	15
           LDW     .D2T1   *+DP(_pri_ctl),A0 ; |70| 
           NOP             4
           SET     .S1     A0,24,24,A0       ; |70| 
           STW     .D2T1   A0,*+DP(_pri_ctl) ; |70| 
	.line	16
           LDW     .D2T1   *+DP(_pri_ctl),A0 ; |71| 
           NOP             4
           CLR     .S1     A0,12,12,A0       ; |71| 
           STW     .D2T1   A0,*+DP(_pri_ctl) ; |71| 
	.line	17
           LDW     .D2T1   *+DP(_pri_ctl),A0 ; |72| 
           NOP             4
           SET     .S1     A0,27,27,A0       ; |72| 
           STW     .D2T1   A0,*+DP(_pri_ctl) ; |72| 
	.line	18
           LDW     .D2T1   *+DP(_pri_ctl),A0 ; |73| 
           NOP             4
           SET     .S1     A0,30,31,A0       ; |73| 
           STW     .D2T1   A0,*+DP(_pri_ctl) ; |73| 
	.line	21
           LDW     .D2T2   *+DP(_sec_ctl),B5 ; |76| 
           NOP             4
           OR      .L2     8,B5,B5           ; |76| 
           STW     .D2T2   B5,*+DP(_sec_ctl) ; |76| 
	.line	22
           LDW     .D2T1   *+DP(_sec_ctl),A0 ; |77| 
           NOP             4
           SET     .S1     A0,9,9,A0         ; |77| 
           STW     .D2T1   A0,*+DP(_sec_ctl) ; |77| 
	.line	23
           LDW     .D2T1   *+DP(_sec_ctl),A0 ; |78| 
           NOP             4
           SET     .S1     A0,13,13,A0       ; |78| 
           STW     .D2T1   A0,*+DP(_sec_ctl) ; |78| 
	.line	24
           LDW     .D2T1   *+DP(_sec_ctl),A0 ; |79| 
           NOP             4

           SHL     .S2X    A8,16,B5          ; |79| 
||         CLR     .S1     A0,16,18,A0       ; |79| 

           OR      .L2X    B5,A0,B5          ; |79| 
           STW     .D2T2   B5,*+DP(_sec_ctl) ; |79| 
	.line	27
           LDW     .D2T1   *+DP(_trans_ctr),A0 ; |82| 
           NOP             4
           CLR     .S1     A0,0,15,A0        ; |82| 
           OR      .L2X    B4,A0,B4          ; |82| 
           STW     .D2T2   B4,*+DP(_trans_ctr) ; |82| 
	.line	28
           LDW     .D2T2   *+DP(_trans_ctr),B4 ; |83| 
           NOP             4

           EXTU    .S2     B4,16,16,B4       ; |83| 
||         SHL     .S1     A6,16,A0          ; |83| 

           OR      .L2X    A0,B4,B4          ; |83| 
           STW     .D2T2   B4,*+DP(_trans_ctr) ; |83| 
	.line	31
           ZERO    .L1     A0                ; |86| 
           MVKH    .S1     0x1600000,A0      ; |86| 
           STW     .D2T1   A0,*+DP(_src_addr) ; |86| 
	.line	34
           STW     .D2T1   A4,*+DP(_dst_addr) ; |89| 
	.line	36
           B       .S2     B3                ; |91| 
           NOP             5
           ; BRANCH OCCURS                   ; |91| 
	.endfunc	91,000000000h,0


;******************************************************************************
;* MARK THE END OF THE SCALAR INIT RECORD IN CINIT:C                          *
;******************************************************************************
CIR:	.sect	".cinit:c"
;******************************************************************************
;* UNDEFINED EXTERNAL REFERENCES                                              *
;******************************************************************************
	.global	_cpu_freq
	.global	_dma_init
	.global	_dma_global_init
